
{**************************************************
*      GETTING GPS DATA 4 MARCH 2012              *
*                                                 *
***************************************************
THIS PROGRAM DEMONSTRATES GETTING GPS DATA, PARSING AND CONVERTING STRINGS TO NUMBERS AS WELL
AS SENDING THE DATA TO EITHER THE PST OR LCD.
   
}
CON
 _clkmode        = xtal1 + pll16x
 _xinfreq        = 5_000_000

 RxPin = 1
   CR = 13                                               ' ASCII <CR>
   LF = 10                                               ' ASCII <LF>

{  LCD ASCII Commands
8 Cursor left
9 Cursor right
10 Cursor down (bottom line will wrap to top line)
12 Clears the display
13 goes to next line
21 Turns display off
22 Turns Display ON
128 - 143 along line 0
148 -163 along line 1
}


          
OBJ
 ss     : "Simple_Serial"
 fds    : "FullDuplexSerial"
 GPS    : "GPS_IO_mini"
 n      : "Numbers"
VAR
long Time, ShortTime
  
Pub Main

    GPS_LCD                     'This sould display the GPS time data to the LCD.  


Pub GPS_LCD
GPS.start(15,9600)               'Starts the GPS data parser to Rx data at 9600

fds.start(-1,4,1,19_200)   ' Data to LCD via FDS (No Rx Pin, Tx on Pin 4, Mode 0 or 1, 19_200 Baud)     
 FDS.tx(22)                  'Turn LCD ON   
 waitcnt(clkfreq/20+cnt)
 FDS.tx(12)                  'Clears screen  
 
'fds.start(31,30,0,57600)        'Sending data to PST via FDS   

repeat
   fds.tx(12)                  'Clears screen
   fds.tx(128)                 'move cursor
   Display_Longitude 
   fds.tx(140)                 'move cursor
   Display_Speed
   
   fds.tx(148)                 'move cursor
   Display_Latitude
   fds.tx(160)
   Display_Heading
   
   waitcnt(clkfreq/2+cnt)
   
Pub Display_Longitude

   fds.str(GPS.longitude)            'Transmits string pointer
    
Pub Display_Latitude

    fds.str(GPS.latitude)            'Transmits string pointer
    
Pub Display_Heading

    fds.str(GPS.Heading)            'Transmits string pointer

Pub Display_Speed

    fds.str(GPS.Speed)            'Transmits string pointer    
   
Pub Display_Time
    
    fds.str(String("GPS String = "))
    fds.str(GPS.time)            'Transmits string pointer to PST displaying the current time                    
    fds.tx(CR)
    fds.tx(LF)

    
    fds.str(String("GPS Time as Variable 'TIME' = ")) 'Converts the string value of time to a 10 digit decimal 
    Time := n.FromStr(GPS.time,10)                     'Using BASE 10 format
    fds.dec(Time)

    
    ShortTime:=Time-5                  'Just playing around and proving to myself that I actually have a real number
    fds.str(String(" ShortTime = "))   'Of course when "Time" ends with 00 the value of ShortTime ends in 95 but that
    fds.dec(ShortTime)                 'was not the point of the exercise

                    
    fds.tx(CR)
    fds.tx(LF)
     
    waitcnt(clkfreq+cnt)        'wait a second just to keep too much data from going to the PST

Pub GPS_String_to_PST|x                'This routine works just fine and sends the NMEA strings to the PST
 ss.init(15,-1,9600)             'Message in on pin 15, no TX (-1) and 9600 baud 
  
 fds.start(31,30,0,57600)       'Sending data to PST must be turned off to use VP terminal 
  
 repeat
   
   x:=ss.rx                     'Receive a byte on pin 3 from the GPS

  fds.tx(x)                    'Transmits data to PST works great w/o VP active 
  